#!/bin/bash
# SECTION 1 - GET VARIABLES 
#set defailt values
dcutheight="2.5" #cut height
dpierceheight="3" #pierce height
dpiercedelay="0.5" #pierce delay
dextension=".ngc" #file extension to ngc
dsafeheight="15" #3 safe height for rapid movements
dfeedrate="1350" #feed rate
newfile="plasma"
# get name of file to be processed
echo Please enter the name of the ngc 'file' to be processed - dont include 'file' extension
read filename
oldfile=$filename
filename=$filename$dextension
# Check if string is empty    
if [[ -z "$filename" ]]; then
   printf '%s\n' "No file name entered"
   exit 1
fi
echo
#if there is a valid file then first make a backup and then show defaults
if [[ -f $filename ]];then 
    cp $filename backup.ngc   
    echo "$filename exists. Please proceed to enter details for:"
    echo
    echo 1. cutting height              - default is $dcutheight
    echo 2. pierce height               - default is $dpierceheight
    echo 3. pierce delay                - default is $dpiercedelay
    echo 4. feed rate                   - default is $dfeedrate
    echo 5. rapid movement safe height  - default is $dsafeheight
    echo
# exit program if wrong or no file esists
else
echo Wrong or 'file' name or 'file' does not exist -- exiting 
exit 1
fi
# establish if defaults are to be applied
read -p "Accept defaults (y/n) " RESP
if [ "$RESP" = "y" ]; then
echo you have accepted defaults
cutheight=$dcutheight
pierceheight=$dpierceheight
piercedelay=$dpiercedelay
feedrate=$dfeedrate
safeheight=$dsafeheight
#echo 'done'
#exit 1
else
        echo
#cutting height
        echo What is the cutting height? - default is $dcutheight mm
        read cutheight
        if [[ -z "$cutheight" ]];then
        cutheight=$dcutheight
        fi
        echo Ok cut height is $cutheight mm
echo
#pierce heightif [[ -z "$cutheight" ]]
        echo What is the pierce height? - default is $dpierceheight mm
        read pierceheight
        if [[ -z "$pierceheight" ]];then
        pierceheight=$dpierceheight
        fi
        echo Ok pierce height is $pierceheight mm
echo
#pierce delay
        echo What is the pierce delay? - default is $dpiercedelay seconds
        read piercedelay
        if [[ -z "$piercedelay" ]];then
        piercedelay=$dpiercedelay
        fi
        echo Ok the pierce delay is $piercedelay seconds
echo
#feed rate
        echo What is the feed rate? - default is $dfeedrate mm/min
        read feedrate
        if [[ -z "$feedrate" ]];then
        feedrate=$dfeedrate
        fi
        echo Ok feed rate is $feedrate mm/min
echo
#safe height for rapid movements
        echo What is the rapid movement safe height? - default is $dsafeheight mm
        read safeheight
        if [[ -z "$safeheight" ]];then
        safeheight=$dsafeheight
        fi
        echo Ok safe height is $safeheight mm
fi
# SECTION 2 EFFECT CHANGES TO THE SELECTED NGC FILE
# todo -1. remove all lines containing the strings "G0 Z" and "G1 Z" - done
#       1(a) remove all lines containing feed rates "F*" done
#       2. replace all lines containing "M9 M5" with " torch off & G0 $safeheight"
#       3. replace all lines containing "M3 M8" with probing cycle
#       4. 
#       5. rename file to $filename[backup] to "plasma"

# put credits in for me!!

sed -i '8i(This file modified by 4cncplasma - By Bruce Lyle)' $filename

# remove all lines containing the strings "G0 Z" and "G1 Z"
sed  -i '/G0 Z\|G1 Z/d' $filename

# remove all lines containing feed rates "F*"
sed  -i '/F/d' $filename  

# replace all lines containing "M9 M5" with "M9 M5 and \nG0 $safeheight"
sed  -i "s/M9 M5/M9 M5 (torch off)\nG0 Z $safeheight (go to safe height)/g" $filename

# replace all lines containing "M3 M8" with probing cycle
sed  -i "s/M3 M8/G38.2 Z-20 (probe for surface)\nG92 Z 0 (set Z offset)\nG1 Z $pierceheight (go to pierce height) \nM3 S1 (torch on) \nG4 P $piercedelay (pierce delay) \nG0 Z $cutheight (go to cut height)\nF $feedrate (set feedrate)/g" $filename

#lastly rename the file to indicate that it's a plasma cutting file and restore the origninal file
mv $filename "$oldfile$newfile$dextension"
mv backup.ngc "$oldfile.ngc"








